﻿Imports Microsoft.Xna.Framework

Namespace demo
    Public Enum ScreenState

        Uninitialized = 0
        LoadingContent = 1
        ContentLoaded = 2
        Transitioning = 3
        Active = 4
        Inactive = 5
        Closed = 6
    End Enum
    Public Class screen
        Public State As ScreenState
        Public ScreenManager As screenmanager
        Public IsPopup As Boolean

        Protected TransitionTime As Single
        Protected TransitionDirection As Integer
        Protected TransitionDuration As Integer

        Public Sub New()
            TransitionDuration = 1
            State = ScreenState.Uninitialized
        End Sub
        Protected Overridable Sub OnShow()

        End Sub
        Public Sub Show()
            State = ScreenState.Transitioning
            TransitionDirection = 1
            OnShow()
        End Sub
        Protected Overridable Sub OnHide()

        End Sub
        Public Sub Hide()
            State = ScreenState.Transitioning
            TransitionDirection = -1
            OnHide()
        End Sub

        Friend Sub Load(callback As Action)
            State = ScreenState.LoadingContent
            OnLoad()
            State = ScreenState.ContentLoaded
        End Sub
        Protected Overridable Sub OnLoad()

        End Sub
        Friend Sub Activate()
            State = ScreenState.Active
            OnActivate()
        End Sub


        Protected Overridable Sub OnActivate()

        End Sub
        Friend Sub Deactivate()
            State = ScreenState.Inactive
            OnDeactivate()
        End Sub

        Protected Overridable Sub OnDeactivate()

        End Sub

        Protected Overridable Sub OnUpdate(gameTime As GameTime)

        End Sub

        Public Sub Update(gameTime As GameTime)
            If (Me.State = ScreenState.Transitioning) Then

                TransitionTime += CSng(gameTime.ElapsedGameTime.TotalSeconds * TransitionDirection / TransitionDuration)
                If (TransitionTime > 1) Then
                    TransitionTime = 1
                    Me.Activate()
                End If

                If (TransitionTime < 0) Then
                    TransitionTime = 0
                    Me.Deactivate()
                End If
            End If
            OnUpdate(gameTime)
        End Sub

        Protected Overridable Sub OnDraw(gameTime As GameTime)

        End Sub

        Public Sub Draw(gameTime As GameTime)
            OnDraw(gameTime)
        End Sub


        Friend Sub Close()
            Me.State = ScreenState.Closed
        End Sub

    End Class

End Namespace


